Index: branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/DiversityCalculator.cs
===================================================================
--- branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/DiversityCalculator.cs	(revision 7774)
+++ branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/DiversityCalculator.cs	(revision 7775)
@@ -42,12 +42,15 @@
     }
 
-    public int ExecuteCalculation(IItem left, IItem right) {
-      if (left == null || right == null) throw new ArgumentException("Cannot calculate diversity because one of the provided objects is null.");
-      if (left.GetType() != right.GetType()) throw new ArgumentException("Cannot calculate diversity because the provided objects differ in type.");
+    public double ExecuteCalculation(IItem left, IItem right) {
+      if (left == null || right == null)
+        throw new ArgumentException("Cannot calculate diversity because one of the provided objects is null.");
+      if (left.GetType() != right.GetType())
+        throw new ArgumentException("Cannot calculate diversity because the provided objects differ in type.");
+
       if (left == right) return 0;
       else return CalculateDiversity(left, right);
     }
 
-    protected abstract int CalculateDiversity(IItem left, IItem right);
+    protected abstract double CalculateDiversity(IItem left, IItem right);
   }
 }
Index: branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/HeuristicLab.Algorithms.ScatterSearch-3.3.csproj
===================================================================
--- branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/HeuristicLab.Algorithms.ScatterSearch-3.3.csproj	(revision 7774)
+++ branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/HeuristicLab.Algorithms.ScatterSearch-3.3.csproj	(revision 7775)
@@ -39,5 +39,4 @@
   </PropertyGroup>
   <ItemGroup>
-    <Reference Include="HeuristicLab.Algorithms.LocalSearch-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" />
     <Reference Include="HeuristicLab.Analysis-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" />
     <Reference Include="HeuristicLab.Collections-3.3">
@@ -55,4 +54,5 @@
     <Reference Include="HeuristicLab.Encodings.BinaryVectorEncoding-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" />
     <Reference Include="HeuristicLab.Encodings.PermutationEncoding-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" />
+    <Reference Include="HeuristicLab.Encodings.RealVectorEncoding-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" />
     <Reference Include="HeuristicLab.Operators-3.3">
       <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Operators-3.3.dll</HintPath>
@@ -72,4 +72,5 @@
     <Reference Include="HeuristicLab.PluginInfrastructure-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" />
     <Reference Include="HeuristicLab.Problems.Knapsack-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" />
+    <Reference Include="HeuristicLab.Problems.TestFunctions-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" />
     <Reference Include="HeuristicLab.Problems.TravelingSalesman-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" />
     <Reference Include="HeuristicLab.Random-3.3">
@@ -86,8 +87,26 @@
   </ItemGroup>
   <ItemGroup>
+    <Compile Include="SolutionPool2TierUpdateMethod.cs" />
     <Compile Include="DiversityCalculator.cs" />
     <Compile Include="IPathRelinker.cs" />
     <Compile Include="Knapsack\BinaryVectorDiversityCalculator.cs" />
+    <Compile Include="Knapsack\KnapsackMultipleGuidesPathRelinker.cs" />
+    <Compile Include="Knapsack\KnapsackSimultaneousPathRelinker.cs" />
     <Compile Include="Knapsack\KnapsackPathRelinker.cs" />
+    <Compile Include="TestFunctions\TestFunctionsZakharovImprovementOperator.cs" />
+    <Compile Include="TestFunctions\TestFunctionsSumSquaresImprovementOperator.cs" />
+    <Compile Include="TestFunctions\TestFunctionsSchwefelImprovementOperator.cs" />
+    <Compile Include="TestFunctions\TestFunctionsRosenbrockImprovementOperator.cs" />
+    <Compile Include="TestFunctions\TestFunctionsMatyasImprovementOperator.cs" />
+    <Compile Include="TestFunctions\TestFunctionsLevyImprovementOperator.cs" />
+    <Compile Include="TestFunctions\TestFunctionsGriewankImprovementOperator.cs" />
+    <Compile Include="TestFunctions\TestFunctionsBoothImprovementOperator.cs" />
+    <Compile Include="TestFunctions\TestFunctionsBealeImprovementOperator.cs" />
+    <Compile Include="TestFunctions\TestFunctionsAckleyImprovementOperator.cs" />
+    <Compile Include="TestFunctions\TestFunctionsPathRelinker.cs" />
+    <Compile Include="TestFunctions\RealVectorDiversityCalculator.cs" />
+    <Compile Include="TestFunctions\TestFunctionsImprovementOperator.cs" />
+    <Compile Include="TravelingSalesman\TravelingSalesmanMultipleGuidesPathRelinker.cs" />
+    <Compile Include="TravelingSalesman\TravelingSalesmanSimultaneousPathRelinker.cs" />
     <Compile Include="TravelingSalesman\TravelingSalesmanPathRelinker.cs" />
     <Compile Include="PathRelinker.cs" />
Index: branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/IScatterSearchTargetProcessor.cs
===================================================================
--- branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/IScatterSearchTargetProcessor.cs	(revision 7774)
+++ branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/IScatterSearchTargetProcessor.cs	(revision 7775)
@@ -23,4 +23,7 @@
 
 namespace HeuristicLab.Algorithms.ScatterSearch {
+  /// <summary>
+  /// An interface which represents an operator that uses a target parameter.
+  /// </summary>
   public interface IScatterSearchTargetProcessor {
     IValueLookupParameter<IItem> TargetParameter { get; }
Index: branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/Knapsack/BinaryVectorDiversityCalculator.cs
===================================================================
--- branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/Knapsack/BinaryVectorDiversityCalculator.cs	(revision 7774)
+++ branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/Knapsack/BinaryVectorDiversityCalculator.cs	(revision 7775)
@@ -20,4 +20,5 @@
 #endregion
 
+using System;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -41,11 +42,13 @@
     }
 
-    protected override int CalculateDiversity(IItem left, IItem right) {
+    protected override double CalculateDiversity(IItem left, IItem right) {
+      if (!(left is BinaryVector) || !(right is BinaryVector))
+        throw new ArgumentException("Cannot calculate diversity because one of the provided objects or both have the wrong type.");
+
       var v1 = left as BinaryVector;
       var v2 = right as BinaryVector;
-      int diversity = 0;
-      if (v1 != null && v2 != null)
-        for (int i = 0; i < v1.Length; i++)
-          if (v1[i] != v2[i]) diversity++;
+      double diversity = 0;
+      for (int i = 0; i < v1.Length; i++)
+        if (v1[i] != v2[i]) diversity++;
       return diversity;
     }
Index: branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/Knapsack/KnapsackImprovementOperator.cs
===================================================================
--- branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/Knapsack/KnapsackImprovementOperator.cs	(revision 7774)
+++ branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/Knapsack/KnapsackImprovementOperator.cs	(revision 7775)
@@ -67,4 +67,7 @@
       get { return (IValueLookupParameter<IItem>)Parameters["Target"]; }
     }
+    public IValueLookupParameter<DoubleValue> PenaltyParameter {
+      get { return (IValueLookupParameter<DoubleValue>)Parameters["Penalty"]; }
+    }
     #region ILocalImprovementOperator Parameters
     public IValueLookupParameter<IntValue> MaximumIterationsParameter {
@@ -99,4 +102,8 @@
       get { return TargetParameter.ActualValue; }
     }
+    private DoubleValue Penalty {
+      get { return PenaltyParameter.ActualValue; }
+      set { PenaltyParameter.ActualValue = value; }
+    }
     #endregion
 
@@ -115,4 +122,5 @@
       Parameters.Add(new ValueLookupParameter<IntValue>("KnapsackCapacity"));
       Parameters.Add(new ValueLookupParameter<IItem>("Target"));
+      Parameters.Add(new ValueLookupParameter<DoubleValue>("Penalty"));
       #endregion
       TargetParameter.ActualName = "KnapsackSolution"; // temporary solution for the knapsack problem
@@ -128,7 +136,7 @@
       // calculate value-to-weight ratio
       double[] ratio = new double[Values.Length];
-      for (int i = 0; i < ratio.Length; i++) {
+      for (int i = 0; i < ratio.Length; i++)
         ratio[i] = (double)Values[i] / (double)Weights[i];
-      }
+
 
       // calculate order for ratio
@@ -140,13 +148,12 @@
 
       int j = sol.Length - 1;
-      while (KnapsackEvaluator.Apply(sol, KnapsackCapacity, new DoubleValue(1.0), Weights, Values).SumWeights.Value > KnapsackCapacity.Value && j >= 0) {
+      while (KnapsackEvaluator.Apply(sol, KnapsackCapacity, Penalty, Weights, Values)
+                              .SumWeights.Value > KnapsackCapacity.Value && j >= 0)
         sol[order[j--]] = false;
-      }
 
       // calculate weight
-      int lhs = 0;
-      for (int i = 0; i < sol.Length; i++) {
-        if (sol[i]) lhs += Weights[i];
-      }
+      int weight = 0;
+      for (int i = 0; i < sol.Length; i++)
+        if (sol[i]) weight += Weights[i];
 
       // improve solution
@@ -154,10 +161,8 @@
       while (feasible && j < sol.Length) {
         while (sol[order[j]]) j++;
-        if (lhs + Weights[order[j]] <= KnapsackCapacity.Value) {
+        if (weight + Weights[order[j]] <= KnapsackCapacity.Value) {
           sol[order[j]] = true;
-          lhs += Weights[order[j]];
-        } else {
-          feasible = false;
-        }
+          weight += Weights[order[j]];
+        } else feasible = false;
       }
 
@@ -166,11 +171,4 @@
       return base.Apply();
     }
-
-    private bool IsFeasiblse(BinaryVector sol) {
-      int sum = 0;
-      for (int i = 0; i < sol.Length; i++)
-        if (sol[i]) sum += Weights[i];
-      return sum <= KnapsackCapacity.Value;
-    }
   }
 }
Index: branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/Knapsack/KnapsackMultipleGuidesPathRelinker.cs
===================================================================
--- branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/Knapsack/KnapsackMultipleGuidesPathRelinker.cs	(revision 7775)
+++ branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/Knapsack/KnapsackMultipleGuidesPathRelinker.cs	(revision 7775)
@@ -0,0 +1,86 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.BinaryVectorEncoding;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Algorithms.ScatterSearch.Knapsack {
+  /// <summary>
+  /// An operator that relinks paths between knapsack solutions using a multiple guiding strategy.
+  /// </summary>
+  [Item("KnapsackMultipleGuidesPathRelinker", "An operator that relinks paths between knapsack solutions using a multiple guiding strategy.")]
+  [StorableClass]
+  public sealed class KnapsackMultipleGuidesPathRelinker : PathRelinker {
+    [StorableConstructor]
+    private KnapsackMultipleGuidesPathRelinker(bool deserializing) : base(deserializing) { }
+    private KnapsackMultipleGuidesPathRelinker(KnapsackMultipleGuidesPathRelinker original, Cloner cloner) : base(original, cloner) { }
+    public KnapsackMultipleGuidesPathRelinker()
+      : base() {
+      ParentsParameter.ActualName = "KnapsackSolution";
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new KnapsackMultipleGuidesPathRelinker(this, cloner);
+    }
+
+    public static ItemArray<IItem> Apply(IItem initiator, IItem[] guides, PercentValue n) {
+      if (!(initiator is BinaryVector) || guides.Any(x => !(x is BinaryVector)))
+        throw new ArgumentException("Cannot relink path because some of the provided solutions have the wrong type.");
+      if (n.Value <= 0.0)
+        throw new ArgumentException("RelinkingAccuracy must be greater than 0.");
+
+      var v1 = initiator.Clone() as BinaryVector;
+      var targets = new BinaryVector[guides.Length];
+      Array.Copy(guides, targets, guides.Length);
+
+      if (targets.Any(x => x.Length != v1.Length))
+        throw new ArgumentException("At least one solution is of different length.");
+
+      var solutions = new List<BinaryVector>();
+      for (int i = 0; i < v1.Length; i++) {
+        // TODO: path relinking
+      }
+
+      var selection = new List<IItem>();
+      if (solutions.Count > 0) {
+        var noSol = (int)Math.Round(solutions.Count * n.Value);
+        if (noSol <= 0) noSol++;
+        var stepSize = (double)solutions.Count / (double)noSol;
+        for (int i = 0; i < noSol; i++)
+          selection.Add(solutions.ElementAt((int)Math.Round((i + 1) * stepSize - stepSize * 0.5)));
+      }
+
+      return new ItemArray<IItem>(selection);
+    }
+
+    protected override ItemArray<IItem> Relink(ItemArray<IItem> parents, PercentValue n) {
+      if (parents.Length != 2)
+        throw new ArgumentException("The number of parents is not equal to 2.");
+      return Apply(parents[0], parents.Skip(1).ToArray(), n);
+    }
+  }
+}
Index: branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/Knapsack/KnapsackPathRelinker.cs
===================================================================
--- branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/Knapsack/KnapsackPathRelinker.cs	(revision 7774)
+++ branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/Knapsack/KnapsackPathRelinker.cs	(revision 7775)
@@ -49,24 +49,29 @@
 
     public static ItemArray<IItem> Apply(IItem initiator, IItem guide, PercentValue n) {
+      if (!(initiator is BinaryVector) || !(guide is BinaryVector))
+        throw new ArgumentException("Cannot relink path because one of the provided solutions or both have the wrong type.");
+      if (n.Value <= 0.0)
+        throw new ArgumentException("RelinkingAccuracy must be greater than 0.");
+
       var v1 = initiator.Clone() as BinaryVector;
       var v2 = guide as BinaryVector;
 
       if (v1.Length != v2.Length)
-        throw new ArgumentException("KnapsackPathRelinker: The solutions are of different length.");
-      if (n.Value == 0.0)
-        throw new ArgumentException("KnapsackPathRelinker: RelinkingAccuracy is 0.");
+        throw new ArgumentException("The solutions are of different length.");
 
       var solutions = new List<BinaryVector>();
-      for (int i = 0; i < v1.Length; i++) {
+      for (int i = 0; i < v1.Length; i++)
         if (v1[i] != v2[i]) {
           v1[i] = v2[i];
-          solutions.Add((BinaryVector)v1.Clone());
+          solutions.Add(v1.Clone() as BinaryVector);
         }
-      }
 
-      var stepSize = 1 / n.Value;
       var selection = new List<IItem>();
-      for (int i = 0; i < solutions.Count; i = (int)Math.Round(i + stepSize)) {
-        selection.Add(solutions.ElementAt(i));
+      if (solutions.Count > 0) {
+        var noSol = (int)Math.Round(solutions.Count * n.Value);
+        if (noSol <= 0) noSol++;
+        var stepSize = (double)solutions.Count / (double)noSol;
+        for (int i = 0; i < noSol; i++)
+          selection.Add(solutions.ElementAt((int)Math.Round((i + 1) * stepSize - stepSize * 0.5)));
       }
 
@@ -75,5 +80,6 @@
 
     protected override ItemArray<IItem> Relink(ItemArray<IItem> parents, PercentValue n) {
-      if (parents.Length != 2) throw new ArgumentException("KnapsackPathRelinker: The number of parents is not equal to 2.");
+      if (parents.Length != 2)
+        throw new ArgumentException("The number of parents is not equal to 2.");
       return Apply(parents[0], parents[1], n);
     }
Index: branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/Knapsack/KnapsackSimultaneousPathRelinker.cs
===================================================================
--- branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/Knapsack/KnapsackSimultaneousPathRelinker.cs	(revision 7775)
+++ branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/Knapsack/KnapsackSimultaneousPathRelinker.cs	(revision 7775)
@@ -0,0 +1,95 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.BinaryVectorEncoding;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Algorithms.ScatterSearch.Knapsack {
+  /// <summary>
+  /// An operator that relinks paths between knapsack solutions starting from both ends.
+  /// </summary>
+  [Item("KnapsackSimultaneousPathRelinker", "An operator that relinks paths between knapsack solutions starting from both ends.")]
+  [StorableClass]
+  public sealed class KnapsackSimultaneousPathRelinker : PathRelinker {
+    [StorableConstructor]
+    private KnapsackSimultaneousPathRelinker(bool deserializing) : base(deserializing) { }
+    private KnapsackSimultaneousPathRelinker(KnapsackSimultaneousPathRelinker original, Cloner cloner) : base(original, cloner) { }
+    public KnapsackSimultaneousPathRelinker()
+      : base() {
+      ParentsParameter.ActualName = "KnapsackSolution";
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new KnapsackSimultaneousPathRelinker(this, cloner);
+    }
+
+    public static ItemArray<IItem> Apply(IItem initiator, IItem guide, PercentValue n) {
+      if (!(initiator is BinaryVector) || !(guide is BinaryVector))
+        throw new ArgumentException("Cannot relink path because one of the provided solutions or both have the wrong type.");
+      if (n.Value <= 0.0)
+        throw new ArgumentException("RelinkingAccuracy must be greater than 0.");
+
+      var firstInitiator = initiator.Clone() as BinaryVector;
+      var firstGuide = guide.Clone() as BinaryVector;
+      var secondInitiator = firstGuide.Clone() as BinaryVector;
+      var secondGuide = firstInitiator.Clone() as BinaryVector;
+
+      if (firstInitiator.Length != firstGuide.Length)
+        throw new ArgumentException("The solutions are of different length.");
+
+      var solutions = new List<BinaryVector>();
+      for (int i = 0; i < firstInitiator.Length / 2; i++) {
+        if (firstInitiator[i] != firstGuide[i]) {
+          firstInitiator[i] = firstGuide[i];
+          solutions.Add(firstInitiator.Clone() as BinaryVector);
+        }
+        var j = secondInitiator.Length - 1 - i;
+        if (secondInitiator[j] != secondGuide[j]) {
+          secondInitiator[j] = secondGuide[j];
+          solutions.Add(secondInitiator.Clone() as BinaryVector);
+        }
+      }
+
+      var selection = new List<IItem>();
+      if (solutions.Count > 0) {
+        var noSol = (int)Math.Round(solutions.Count * n.Value);
+        if (noSol <= 0) noSol++;
+        var stepSize = (double)solutions.Count / (double)noSol;
+        for (int i = 0; i < noSol; i++)
+          selection.Add(solutions.ElementAt((int)Math.Round((i + 1) * stepSize - stepSize * 0.5)));
+      }
+
+      return new ItemArray<IItem>(selection);
+    }
+
+    protected override ItemArray<IItem> Relink(ItemArray<IItem> parents, PercentValue n) {
+      if (parents.Length != 2)
+        throw new ArgumentException("The number of parents is not equal to 2.");
+      return Apply(parents[0], parents[1], n);
+    }
+  }
+}
Index: branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/Knapsack/NBinaryVectorCrossover.cs
===================================================================
--- branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/Knapsack/NBinaryVectorCrossover.cs	(revision 7774)
+++ branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/Knapsack/NBinaryVectorCrossover.cs	(revision 7775)
@@ -72,7 +72,6 @@
     public sealed override IOperation Apply() {
       var offspringSolutions = Cross(RandomParameter.ActualValue, ParentsParameter.ActualValue);
-      for (int i = 0; i < offspringSolutions.Length; i++) {
+      for (int i = 0; i < offspringSolutions.Length; i++)
         CurrentScope.Variables.Add(new Variable(string.Format("Child {0}", i), offspringSolutions[i]));
-      }
       return base.Apply();
     }
Index: branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/Knapsack/NChildCrossover.cs
===================================================================
--- branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/Knapsack/NChildCrossover.cs	(revision 7774)
+++ branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/Knapsack/NChildCrossover.cs	(revision 7775)
@@ -58,8 +58,6 @@
       if (parent1.Length != parent2.Length)
         throw new ArgumentException("NChildCrossover: The parents are of different length.");
-
       if (n.Value > Math.Pow(2, parent1.Length) - 2)
         throw new ArgumentException("NChildCrossover: There cannot be more children than 2^size of parents - 2.");
-
       if (n.Value < 1)
         throw new ArgumentException("NChildCrossover: N cannot be < 1.");
@@ -68,7 +66,6 @@
       for (int i = 0; i < n.Value; i++) {
         var solution = new BinaryVector(parent1.Length);
-        for (int j = 0; j < solution.Length; j++) {
+        for (int j = 0; j < solution.Length; j++)
           solution[j] = random.Next(2) % 2 == 0 ? parent1[j] : parent2[j];
-        }
         solutions[i] = solution;
       }
@@ -78,8 +75,8 @@
 
     protected override ItemArray<BinaryVector> Cross(IRandom random, ItemArray<BinaryVector> parents) {
-      if (parents.Length != 2) throw new ArgumentException("NChildCrossover: The number of parents is not equal to 2.");
-
-      if (NParameter.ActualValue == null) throw new InvalidOperationException("NChildCrossover: Parameter " + NParameter.ActualName + " could not be found.");
-
+      if (parents.Length != 2)
+        throw new ArgumentException("NChildCrossover: The number of parents is not equal to 2.");
+      if (NParameter.ActualValue == null)
+        throw new InvalidOperationException("NChildCrossover: Parameter " + NParameter.ActualName + " could not be found.");
       return Apply(random, parents[0], parents[1], NParameter.Value);
     }
Index: branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/PathRelinker.cs
===================================================================
--- branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/PathRelinker.cs	(revision 7774)
+++ branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/PathRelinker.cs	(revision 7775)
@@ -31,5 +31,5 @@
   /// A base class for operators that perform path relinking.
   /// </summary>
-  [Item("PathRelinker", "A base class for operators that perform a crossover of bool-valued vectors.")]
+  [Item("PathRelinker", "A base class for operators that perform path relinking.")]
   [StorableClass]
   public abstract class PathRelinker : SingleSuccessorOperator, IPathRelinker {
@@ -38,6 +38,6 @@
       get { return (ScopeParameter)Parameters["CurrentScope"]; }
     }
-    public IValueLookupParameter<PercentValue> RelinkingAccuracyParameter {
-      get { return (IValueLookupParameter<PercentValue>)Parameters["RelinkingAccuracy"]; }
+    public IValueParameter<PercentValue> RelinkingAccuracyParameter {
+      get { return (IValueParameter<PercentValue>)Parameters["RelinkingAccuracy"]; }
     }
     public ILookupParameter<ItemArray<IItem>> ParentsParameter {
@@ -50,4 +50,10 @@
       get { return CurrentScopeParameter.ActualValue; }
     }
+    private PercentValue RelinkingAccuracy {
+      get { return RelinkingAccuracyParameter.Value; }
+    }
+    private ItemArray<IItem> Parents {
+      get { return ParentsParameter.ActualValue; }
+    }
     #endregion
 
@@ -59,5 +65,5 @@
       #region Create parameters
       Parameters.Add(new ScopeParameter("CurrentScope"));
-      Parameters.Add(new ValueLookupParameter<PercentValue>("RelinkingAccuracy", new PercentValue(0.25)));
+      Parameters.Add(new ValueParameter<PercentValue>("RelinkingAccuracy", new PercentValue(0.25)));
       Parameters.Add(new ScopeTreeLookupParameter<IItem>("Parents"));
       #endregion
@@ -65,8 +71,7 @@
 
     public sealed override IOperation Apply() {
-      var relinkedSolutions = Relink(ParentsParameter.ActualValue, RelinkingAccuracyParameter.ActualValue);
-      for (int i = 0; i < relinkedSolutions.Length; i++) {
+      var relinkedSolutions = Relink(Parents, RelinkingAccuracy);
+      for (int i = 0; i < relinkedSolutions.Length; i++)
         CurrentScope.Variables.Add(new Variable(string.Format("Child {0}", i), relinkedSolutions[i]));
-      }
       return base.Apply();
     }
Index: branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/Plugin.cs.frame
===================================================================
--- branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/Plugin.cs.frame	(revision 7774)
+++ branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/Plugin.cs.frame	(revision 7775)
@@ -26,5 +26,5 @@
   /// Plugin class for HeuristicLab.Algorithms.ScatterSearch plugin.
   /// </summary>
-  [Plugin("HeuristicLab.Algorithms.ScatterSearch", "3.3.6.$WCREV$")]
+  [Plugin("HeuristicLab.Algorithms.ScatterSearch", "3.3.6.7756")]
   [PluginFile("HeuristicLab.Algorithms.ScatterSearch-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Analysis", "3.3")]
@@ -33,4 +33,7 @@
   [PluginDependency("HeuristicLab.Core", "3.3")]
   [PluginDependency("HeuristicLab.Data", "3.3")]
+  [PluginDependency("HeuristicLab.Encodings.BinaryVectorEncoding", "3.3")]
+  [PluginDependency("HeuristicLab.Encodings.PermutationEncoding", "3.3")]
+  [PluginDependency("HeuristicLab.Encodings.RealVectorEncoding", "3.3")]
   [PluginDependency("HeuristicLab.Operators", "3.3")]
   [PluginDependency("HeuristicLab.Optimization", "3.3")]
@@ -38,4 +41,7 @@
   [PluginDependency("HeuristicLab.Parameters", "3.3")]
   [PluginDependency("HeuristicLab.Persistence", "3.3")]
+  [PluginDependency("HeuristicLab.Problems.Knapsack", "3.3")]
+  [PluginDependency("HeuristicLab.Problems.TestFunctions", "3.3")]
+  [PluginDependency("HeuristicLab.Problems.TravelingSalesman", "3.3")]
   [PluginDependency("HeuristicLab.Random", "3.3")]
   [PluginDependency("HeuristicLab.Selection", "3.3")]
Index: branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/ReferenceSetUpdateMethod.cs
===================================================================
--- branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/ReferenceSetUpdateMethod.cs	(revision 7774)
+++ branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/ReferenceSetUpdateMethod.cs	(revision 7775)
@@ -95,5 +95,5 @@
       var population = new Dictionary<IScope, double>();
       foreach (var pScope in CurrentScope.SubScopes[0].SubScopes) {
-        int diversity = 0;
+        double diversity = 0;
         var pSol = pScope.Variables[TargetParameter.ActualName].Value;
         foreach (var rScope in CurrentScope.SubScopes[1].SubScopes) {
